'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const path = require('path');

const index = (({
  types: t,
  template
}, options) => {
  const injectOptions = Object.entries(options.declarations ?? {}).map(([identifier, imports]) => {
    if (imports[0][0] === ".") {
      imports = [path.resolve(imports[0]), imports[1]];
    }

    return [identifier, imports[0], imports[1] == null ? template.statement.ast(`import '${imports[0]}'`) : imports[1] === "default" ? template.statement.ast(`import ${identifier} from '${imports[0]}'`) : imports[1] === "*" ? template.statement.ast(`import * as ${identifier} from '${imports[0]}'`) : imports[1] === identifier ? template.statement.ast(`import { ${identifier} } from '${imports[0]}'`) : template.statement.ast(`import { ${imports[1]} as ${identifier} } from '${imports[0]}'`)];
  });
  return {
    visitor: {
      Program(path, state) {
        const globals = path.scope.globals;
        const importNodes = injectOptions.filter(([identifier, importFileName]) => globals[identifier] && state.filename !== importFileName).map(([_identifier, _importFileName, importNode]) => t.cloneNode(importNode, true));
        path.unshiftContainer("body", importNodes);
      }

    }
  };
});

exports.default = index;
//# sourceMappingURL=index.js.map
